<?php
/**
 * Created by PhpStorm.
 * User: sunbing
 * Date: 2021-07-07
 * Time: 14:14
 */


if (!defined('IN_DISCUZ')) {
    exit('Access Denied');
}

class mobileplugin_qfthread
{
    public $is_open = false;

    public function __construct()
    {
        global $_G;

        if (!$_G['cache']['plugin']['qfthread']) {
            return;
        }

        if ($_G['cache']['plugin']['qfthread']['isopen']) {
            $this->is_open = true;
        }
    }

    public function common()
    {
        if (isset($_GET['mod']) && $_GET['mod'] == 'space' && !empty($_GET['uid'])) {
            global $_G;
            $config = $_G['cache']['plugin']['qfthread'];
            if (!empty($config['ban_space_tips'])) {
                $msg = $config['ban_space_tips'];
            } else {
                $msg = 'space_has_been_locked';
            }

            if (isset($config['ban_space']) && $config['ban_space'] == 3) {
                showmessage($msg, NULL);
            }
            if (isset($config['ban_space']) && $config['ban_space'] == 2) {
                $uid = (int)$_GET['uid'];
                $userPhone = DB::result_first('SELECT phone FROM %t WHERE uid=%d', array('phonebind', $uid));
                $userMobile = DB::result_first('SELECT mobile FROM %t WHERE uid=%d', array('common_member_profile', $uid));
                $lastvist = DB::result_first('SELECT lastactivity FROM %t WHERE uid=%d', array('common_member_status', $uid));
                if ((!$userMobile && !$userPhone) || ((TIMESTAMP - $lastvist) > 3600 * 24 * 180)) {
                    showmessage($msg, NULL);
                }
            }
        }
    }

}

class mobileplugin_qfthread_forum extends mobileplugin_qfthread
{

    public function __construct()
    {
        parent::__construct();
    }

    public function viewthread_title_extra()
    {
        global $_G;

        if (!empty($_G['cache']['plugin']['qfthread']['tips'])) {
            $msg = $_G['cache']['plugin']['qfthread']['tips'];
        } else {
            $msg = 'post_nonexistence';
        }

        if ($this->is_open && !empty($_G['thread'])) {

            $whiteuids = array();
            if (!empty($_G['cache']['plugin']['qfthread']['whiteuids'])) {
                $whiteuids = explode(',', $_G['cache']['plugin']['qfthread']['whiteuids']);
            }
            $whitetids = array();
            if (!empty($_G['cache']['plugin']['qfthread']['whitetids'])) {
                $whitetids = explode(',', $_G['cache']['plugin']['qfthread']['whitetids']);
            }
            $whitetauthorids = array();
            if (!empty($_G['cache']['plugin']['qfthread']['authorids'])) {
                $whitetauthorids = explode(',', $_G['cache']['plugin']['qfthread']['authorids']);
            }
            if (in_array($_G['uid'], $whiteuids) || in_array($_G['tid'], $whitetids) || in_array($_G['thread']['authorid'], $whitetauthorids)) {
                return null;
            }

            if (!empty($_G['cache']['plugin']['qfthread']['enableauthor']) && $_G['uid'] && $_G['uid'] == $_G['thread']['authorid']) {
                return null;
            }

            $limitFids = (array)unserialize($_G['cache']['plugin']['qfthread']['forums']);
            $limitFids = array_values(array_filter($limitFids));

            $limitGroups = (array)unserialize($_G['cache']['plugin']['qfthread']['groups']);
            $limitGroups = array_values(array_filter($limitGroups));


            if ((in_array($_G['fid'], $limitFids)) && (in_array($_G['groupid'], $limitGroups))) {
                if (!empty($_G['cache']['plugin']['qfthread']['bantime'])) {
                    if ($_G['thread']['dateline'] <= strtotime($_G['cache']['plugin']['qfthread']['bantime'])) {
                        showmessage($msg);
                    }
                }

                if (!empty($_G['cache']['plugin']['qfthread']['limitdays'])) {
                    $limitTime = time() - 60 * 60 * 24 * (int)$_G['cache']['plugin']['qfthread']['limitdays'];
                    if (!empty($_G['thread'])) {
                        if ($_G['thread']['dateline'] <= $limitTime) {
                            showmessage($msg);
                        }
                    }
                }
            }

        }
        return null;
    }
}